package org.codehaus.xfire.java;

import java.util.Collection;
import java.util.List;

import org.codehaus.xfire.MessageContext;
import org.codehaus.xfire.fault.XFireFault;
import org.codehaus.xfire.java.mapping.TypeMapping;
import org.codehaus.xfire.service.Service;

/** 
 * @author <a href="mailto:dan@envoisolutions.com">Dan Diephouse</a>
 * @since Feb 18, 2004
 */
public interface JavaService
    extends Service
{
    public final static int SCOPE_APPLICATION = 1;
    
    public final static int SCOPE_SESSION = 2;
    
    public final static int SCOPE_REQUEST = 3;
    
    TypeMapping getTypeMapping();
    
    List getAllowedMethods();

	Operation getOperation( String localName, String namespace );
    
    Class getServiceClass();

    Collection getOperations();
    
    int getScope();
    
    Object getServiceObject( MessageContext context ) throws XFireFault;
}
