package org.codehaus.xfire.java.message;

import java.util.Calendar;
import java.util.Date;

/**
 * Writes messages to an output stream.  When using the MessageWriter
 * a strict contract must be followed. 
 * 
 * TODO: elaborate on contract
 * 
 * @author <a href="mailto:dan@envoisolutions.com">Dan Diephouse</a>
 */
public interface MessageWriter
{
    void writeValue( Object value );

    void writeValueAsCalendar( Calendar calendar );

    void writeValueAsDate( Date date );
    
    void writeValueAsDateTime( Date date );
    
    //void writeValueAsTime( Date date );

    void writeValueAsInt( Integer i );

    void writeValueAsDouble(Double double1);

    void writeValueAsLong(Long l);

    void writeValueAsFloat(Float f);

    MessageWriter getChildWriter(String name);

    MessageWriter getChildWriter(String name, String namespace);
       
    String getNamespace();
    
    void setNamespace( String namespace );

	/**
	 * @param b
	 */
	void writeValueAsBoolean(boolean b);
    
    /**
     * Tells the MessageWriter that writing operations are completed so 
     * it can write the end element.
     */
    void close();
}
